//
// See the file LICENSE for redistribution information.
//
// Copyright (c) 2002-2004
//	Sleepycat Software.  All rights reserved.
//
// $Id: XmlMetaDataIterator.cpp,v 1.1 2004/09/02 09:33:07 jsnelson Exp $
//

#include "dbxml_config.h"
#include <dbxml/XmlMetaDataIterator.hpp>
#include "Document.hpp"

using namespace DbXml;

XmlMetaDataIterator::XmlMetaDataIterator(MetaDataIterator *i)
	: i_(i)
{
	i_->acquire();
}

XmlMetaDataIterator::~XmlMetaDataIterator()
{
	i_->release();
}

XmlMetaDataIterator::XmlMetaDataIterator(const XmlMetaDataIterator &o)
	: i_(o.i_)
{
	i_->acquire();
}

XmlMetaDataIterator &XmlMetaDataIterator::operator=(const XmlMetaDataIterator &o)
{
	if (this != &o && i_ != o.i_) {
		i_->release();
		i_ = o.i_;
		i_->acquire();
	}
	return *this;
}

bool XmlMetaDataIterator::next(std::string &uri, std::string &name, XmlValue &value)
{
	return i_->next(uri, name, value);
}

void XmlMetaDataIterator::reset()
{
	i_->reset();
}
