//
// See the file LICENSE for redistribution information.
//
// Copyright (c) 2002-2004
//	Sleepycat Software.  All rights reserved.
//
// $Id: CollectionAndDocOptimizer.cpp,v 1.3 2004/08/23 17:05:48 jsnelson Exp $
//

#include "dbxml/XmlPortability.hpp"
#include "CollectionAndDocOptimizer.hpp"
#include "../UTF8.hpp"
#include "../dataItem/QueryPlanFunction.hpp"

#include <pathan/functions/FunctionDoc.hpp>
#include <pathan/functions/FunctionCollection.hpp>

using namespace DbXml;

DataItem *CollectionAndDocOptimizer::optimizeFunction(DataItemFunction *item)
{
  const XMLCh *uri = item->getFunctionURI();
  const XMLCh *name = item->getFunctionName();

  // Replace fn:doc() or fn:collection() with our fn:QueryPlanFunction()
  if(uri == DataItemFunction::XMLChFunctionURI &&
     (name == FunctionDoc::name
      || name == FunctionCollection::name)) {

    QueryPlanFunction::Type type = 
      (name == FunctionDoc::name ? QueryPlanFunction::DOCUMENT : QueryPlanFunction::COLLECTION);
    QueryPlanFunction *result = new (xpc_->getMemoryManager()) QueryPlanFunction(minder_, type, item->getArguments(), xpc_->getMemoryManager());
    result->addPredicates(item->getPredicates());
    item = result;
  }

  return NodeVisitingOptimizer::optimizeFunction(item);
}
