//
// See the file LICENSE for redistribution information.
//
// Copyright (c) 2002-2004
//	Sleepycat Software.  All rights reserved.
//
// $Id: AbortCommand.cpp,v 1.4 2004/09/10 11:32:10 jsnelson Exp $
//

#include "AbortCommand.hpp"

using namespace DbXml;
using namespace std;

string AbortCommand::getCommandName() const
{
  return "abort";
}

string AbortCommand::getBriefHelp() const
{
  return "Aborts the current transaction, and starts a new one";
}

string AbortCommand::getMoreHelp() const
{
  return
    string("Takes no arguments. This command uses the XmlTransaction::abort()\n") +
    string("method.");
}

void AbortCommand::execute(Args &args, Environment &env)
{
  if(args.size() != 1) {
    throw CommandException("Wrong number of arguments");
  }

  env.testTransaction();
  env.abortTransaction();
  delete env.txn();
  env.txn() = 0;
  if(env.verbose()) cout << "Transaction aborted" << endl;
}

